
(function(l, r) { if (l.getElementById('livereloadscript')) return; r = l.createElement('script'); r.async = 1; r.src = '//' + (window.location.host || 'localhost').split(':')[0] + ':35729/livereload.js?snipver=1'; r.id = 'livereloadscript'; l.getElementsByTagName('head')[0].appendChild(r) })(window.document);
var Transform2D = ({
  Matrix = DOMMatrixReadOnly,
  Quad = DOMQuad,
  viewport = { width: 0, height: 0 },
  initTransform = new Matrix(),
  maxScale = Infinity,
  minScale = 0,
  fitViewRatio = 1,
}) => {
  const core = {
    maxScale,
    minScale,
    fitViewRatio,
    viewport,
    transform: initTransform,
    translate(dx = 0, dy = 0) {
      if (typeof dx !== "number" || typeof dy !== "number") {
        throw "dx and dy should be numbers.";
      }
      this.transform = new Matrix().translate(dx, dy).multiply(this.transform);
    },
    rotate(angle = 0, origin = { x: 0, y: 0 }) {
      if (typeof angle !== "number") {
        throw "Angle must be a number (degree)";
      }
      this.transform = this.transform.multiply(
        new Matrix()
          .translate(origin.x, origin.y)
          .rotate(angle)
          .translate(-origin.x, -origin.y)
      );
    },
    scale(factor = 1, origin = { x: 0, y: 0 }) {
      if (factor < 0) {
        throw "Scale factor should be > 0.";
      }
      let clampedFactor = factor;
      const scale = this.getScale();
      if (scale * clampedFactor >= maxScale) {
        clampedFactor = maxScale / scale;
      }
      if (scale * clampedFactor <= minScale) {
        clampedFactor = minScale / scale;
      }
      this.transform = this.transform.scale(
        clampedFactor,
        clampedFactor,
        1,
        origin.x,
        origin.y
      );
    },
    getTranslate(translateM = this.transform) {
      return { dx: translateM.e, dy: translateM.f };
    },
    getRotate(rotateM = this.transform) {
      return (
        (Math.atan2(rotateM.b / this.getScale(), rotateM.a / this.getScale()) *
          180) /
        Math.PI
      );
    },
    getScale(scaleM = this.transform) {
      return Math.sqrt(Math.pow(scaleM.a, 2) + Math.pow(scaleM.b, 2));
    },
    resetTranslate() {
      this.setState({ translate: { dx: 0, dy: 0 } });
    },
    resetRotate() {
      this.setState({ rotate: 0 });
    },
    resetScale() {
      this.setState({ scale: 1 });
    },
    setState({
      rotate = this.getRotate(),
      translate = this.getTranslate(),
      scale = this.getScale(),
    } = {}) {
      if (typeof translate !== "object") {
        throw `'translate' argument should be an object, received '${typeof translate}'.`;
      }
      if (typeof rotate !== "number") {
        throw `'rotate' argument should be a number, received '${typeof rotate}'.`;
      }
      if (typeof scale !== "number") {
        throw `'scale' argument should be a number, received '${typeof scale}'.`;
      }
      const { dx = 0, dy = 0 } = translate;
      this.transform = new Matrix()
        .translate(dx, dy)
        .rotate(rotate)
        .scale(scale);
    },
    fitView(quad = {}, ratio = this.fitViewRatio) {
      this.transform = new Matrix().rotate(this.getRotate());
      const { x, y, width, height } = this.getViewRectFromQuad(quad);
      const quadCenter = {
        x: x + width / 2,
        y: y + height / 2,
      };
      const viewportCenter = {
        x: this.viewport.width / 2,
        y: this.viewport.height / 2,
      };
      const scaleFactor = Math.min(
        this.viewport.width / width,
        this.viewport.height / height
      );
      const translateTarget = {
        x: viewportCenter.x - quadCenter.x,
        y: viewportCenter.y - quadCenter.y,
      };
      this.translate(translateTarget.x, translateTarget.y);
      this.scale(scaleFactor * ratio, this.getTransformedPoint(viewportCenter));
    },
    getTransformedPoint(point) {
      return this.transform.inverse().transformPoint(point);
    },
    getViewPoint(point) {
      return this.transform.transformPoint(point);
    },
    getViewRectFromQuad(quad = {}) {
      return new Quad(
        ...Object.values(quad).map(this.getViewPoint.bind(this))
      ).getBounds();
    },
  };

  return {
    translate(dx, dy) {
      return core.translate(dx, dy);
    },
    rotate(angle, origin) {
      return core.rotate(angle, core.getTransformedPoint(origin));
    },
    scale(factor, origin) {
      return core.scale(factor, core.getTransformedPoint(origin));
    },
    fitView(quad, ratio) {
      return core.fitView(quad, ratio);
    },
    getTransform() {
      return core.transform;
    },
  };
};

function* idGenerator() {
  let i = 1;
  while (i < Number.MAX_SAFE_INTEGER) {
    yield i++;
  }
  throw "Cannot generate more ids";
}

function makeIdGenerator() {
  const gen = idGenerator();
  return () => gen.next().value;
}

function getQuadFromBBox(bbox = []) {
  if (!bbox || bbox.length !== 4) {
    throw "bbox have to be an array with x1, y1, x2, y2 values";
  }
  const [x1, y1, x2, y2] = bbox;
  return {
    p1: { x: x1, y: y1 },
    p2: { x: x2, y: y1 },
    p3: { x: x2, y: y2 },
    p4: { x: x1, y: y2 },
  };
}

function capitalCaseFirstLetter(str = "") {
  return str[0].toUpperCase() + str.slice(1);
}

/******* COLORS *******/

// after this value, the color restart to rgb(0,0,0)
const maxColorId = 838860799;
// a step should be added to prevent antialiasing to leads to wrong id detection
const colorStep = 50;

function getRGBStringColorFromId(id = 0) {
  if (id < 0 || id * colorStep > maxColorId) {
    throw `Impossible to generate unique color from id ${id}.`;
  }
  const rgb = [];
  rgb.push((id * colorStep) & 0xff); // R.
  rgb.push(((id * colorStep) & 0xff00) >> 8); // G.
  rgb.push(((id * colorStep) & 0xff0000) >> 16); // B.
  return `rgb(${rgb.join(",")})`;
}

const getIdFromRGBColor = function (color) {
  if (!color || color.length < 3) {
    throw "color must be an array with at least 3 values.";
  }
  const R = color[0];
  const G = color[1];
  const B = color[2];

  return R / colorStep + (G * 256) / colorStep + (B * 256 * 256) / colorStep;
};

function fromUint8ArrayColorToStringColor(color, opacity = 1) {
  return `rgba(${color[0]},${color[1]},${color[2]},${opacity})`;
}

function makeEventHandler() {
  const idGenerator = makeIdGenerator();
  const subscriptions = new Map();
  const eventHandlers = new Map();

  return {
    on(eventName, callback) {
      if (typeof callback !== "function") {
        throw `callback must be a function, get ${typeof callback}`;
      }
      const subscriptionId = idGenerator();
      subscriptions.set(subscriptionId, { eventName, callback });
      if (eventHandlers.has(eventName)) {
        eventHandlers.get(eventName).push(callback);
      } else {
        eventHandlers.set(eventName, [callback]);
      }
      return subscriptionId;
    },
    once(eventName, callback) {
      if (typeof callback !== "function") {
        throw `callback must be a function, get ${typeof callback}`;
      }
      const subscriptionId = this.on(eventName, (...args) => {
        this.off(subscriptionId);
        callback(...args);
      });
      return subscriptionId;
    },
    off(subscriptionId) {
      const subscription = subscriptions.get(subscriptionId);
      if (subscription) {
        const { eventName, callback } = subscription;
        const handlers = eventHandlers
          .get(eventName)
          .filter(handler => handler !== callback);
        if (handlers.length) {
          eventHandlers.set(eventName, handlers);
        } else {
          eventHandlers.delete(eventName);
        }
        subscriptions.delete(subscriptionId);
      }
    },
    emit(eventName, payload) {
      const handlers = eventHandlers.get(eventName) || [];
      handlers.forEach(handler => handler(payload));
    },
    clear() {
      subscriptions.clear();
      eventHandlers.clear();
    },
  };
}

var UI = el => {
  if (!(el instanceof HTMLElement)) {
    throw "el must be a HTMLElement";
  }

  const events = makeEventHandler();
  const state = {
    dragging: false,
    rightClick: false,
  };

  el.addEventListener("mousedown", () => {
    document.addEventListener("mousemove", onDrag);
    document.addEventListener("mouseup", onMouseUp);
  });

  function onDrag(e) {
    if (e.movementX === 0 && e.movementY === 0) return;
    state.dragging = true;
    document.body.style.cursor = "move";
    events.emit("drag", {
      dx: e.movementX * window.devicePixelRatio,
      dy: e.movementY * window.devicePixelRatio,
      keys: keys(e),
    });
  }
  function onMouseUp(e) {
    document.removeEventListener("mousemove", onDrag);
    document.removeEventListener("mouseup", onMouseUp);
    document.body.style.cursor = null;
    if (!state.dragging) {
      events.emit(state.rightClick ? "right-click" : "click", {
        position: position(e),
        keys: keys(e),
      });
    }
    state.dragging = false;
    state.rightClick = false;
  }

  el.addEventListener("wheel", e => {
    e.preventDefault();
    events.emit("wheel", {
      position: position(e),
      dx: e.deltaX,
      dy: e.deltaY,
      keys: keys(e),
    });
  });

  el.addEventListener("contextmenu", e => {
    e.preventDefault();
    state.rightClick = true;
  });

  el.addEventListener("mousemove", e => {
    if (!state.dragging) {
      events.emit("move", { position: position(e), keys: keys(e) });
    }
  });

  window.addEventListener("keydown", e => {
    if (e.target.tagName === "INPUT" || e.target.tagName === "TEXTAREA") return;
    e.preventDefault();
    switch (event.key) {
      case "ArrowDown": {
        events.emit("arrow-down", { keys: keys(e) });
        break;
      }
      case "ArrowUp":
        events.emit("arrow-up", { keys: keys(e) });
        break;
      case "ArrowLeft":
        events.emit("arrow-left", { keys: keys(e) });
        break;
      case "ArrowRight":
        events.emit("arrow-right", { keys: keys(e) });
        break;
    }
  });

  return { ...events };
};

function keys(event = {}) {
  return {
    ctrl: event.ctrlKey,
    alt: event.altKey,
    shift: event.shiftKey,
    meta: event.metaKey,
  };
}

function position(event = {}) {
  return {
    x: event.offsetX * window.devicePixelRatio,
    y: event.offsetY * window.devicePixelRatio,
  };
}

function makeRenderer(canvas = {}) {
  const visibleContext = canvas.getContext("2d");
  if (!visibleContext) {
    throw "Impossible to make renderer. Can not get canvas 2d context.";
  }

  const events = makeEventHandler();

  const layers = new Map();

  resize();

  function resize() {
    // Using parseInt because window.devicePixelRatio is a float and can return half pixels
    const viewportWidth = parseInt(
      canvas.clientWidth * window.devicePixelRatio
    );
    const viewportHeight = parseInt(
      canvas.clientHeight * window.devicePixelRatio
    );
    if (canvas.width !== viewportWidth || canvas.height !== viewportHeight) {
      const dx = viewportWidth - canvas.width;
      const dy = viewportHeight - canvas.height;
      resizeAll(viewportWidth, viewportHeight);
      events.emit("resize", { dx, dy });
    }
  }

  function resizeAll(width, height) {
    getContexts().forEach(context => {
      context.canvas.width = width;
      context.canvas.height = height;
    });
  }

  function getContexts() {
    return [visibleContext, ...getLayers().map(layer => layer.context)];
  }

  function getLayers() {
    return Array.from(layers.values());
  }

  function makeLayer(objects, visible, batchPath) {
    return {
      _objects: objects,
      get objects() {
        return this._objects;
      },
      set objects(newObjects) {
        this.rendered = false;
        if (this.batchPath) {
          this.materialsBatchPath.clear();
        }
        this._objects = newObjects;
      },
      visible,
      context: setOffscreenContext(canvas.width, canvas.height),
      rendered: false,
      setTransform(transform) {
        this.rendered = false;
        this.context.setTransform(transform);
      },
      batchPath,
      materialsBatchPath: batchPath ? new Map() : undefined,
    };
  }

  function drawLayer(layer) {
    visibleContext.drawImage(layer.context.canvas, 0, 0);
    return layer;
  }

  return {
    transform: visibleContext.getTransform(),
    transformChanged: true,
    setTransform(t) {
      if (this.transform !== t) {
        this.transform = t;
        this.transformChanged = true;
      }
    },
    getViewport() {
      return {
        get width() {
          return canvas.width;
        },
        get height() {
          return canvas.height;
        },
      };
    },
    addLayer(name, objects, visible = true, batchPath = true) {
      const layer = makeLayer(objects, visible, batchPath);
      layers.set(name, layer);
      return layer;
    },
    setLayerObjects(name, objects) {
      if (!layers.has(name)) {
        throw `Layer "${name}" does not exist.`;
      }
      const layer = layers.get(name);
      layer.objects = objects;
    },
    render() {
      resize();
      if (this.transformChanged) {
        getLayers().forEach(layer => layer.setTransform(this.transform));
        this.transformChanged = false;
      }

      const layersToRedraw = getLayers().filter(layer => !layer.rendered);

      if (layersToRedraw.length > 0) {
        layersToRedraw.map(clearLayer).forEach(renderLayer);

        clear(visibleContext);

        getLayers()
          .filter(layer => layer.visible && layer.objects.length)
          .forEach(drawLayer);
      }
    },
    ...events,
  };
}

function setOffscreenContext(width, height) {
  const offscreenCanvas = document.createElement("canvas");
  offscreenCanvas.width = width;
  offscreenCanvas.height = height;
  return offscreenCanvas.getContext("2d");
}

function makeBatchPath(objects) {
  const batchPath = new Path2D();
  objects.forEach(object => batchPath.addPath(object.path));
  return batchPath;
}

function clearLayer(layer) {
  clear(layer.context);
  return layer;
}

function clear(context) {
  context.save();
  context.resetTransform();
  context.clearRect(0, 0, context.canvas.width, context.canvas.height);
  context.restore();
  return context;
}

function renderLayer(layer) {
  if (layer.batchPath) {
    const objectsByMaterial = new Map();
    layer.objects.forEach(object => {
      if (objectsByMaterial.has(object.material)) {
        objectsByMaterial.get(object.material).push(object);
      } else {
        objectsByMaterial.set(object.material, [object]);
      }
    });
    objectsByMaterial.forEach((objects, material) => {
      let batchPath = null;
      if (layer.materialsBatchPath.has(material)) {
        batchPath = layer.materialsBatchPath.get(material);
      } else {
        batchPath = makeBatchPath(objects);
        layer.materialsBatchPath.set(material, batchPath);
      }
      renderPath(layer.context, batchPath, material);
    });
  } else {
    layer.objects.forEach(object =>
      renderPath(layer.context, object.path, object.material)
    );
  }

  layer.rendered = true;
  return layer;
}

function renderPath(context, path, material) {
  setContextMaterial(context, material);
  if (material.strokeStyle) {
    context.stroke(path);
  }
  if (material.fillStyle) {
    context.fill(path);
  }
}

function setContextMaterial(context, material) {
  context.lineWidth = material.strokeStyle && material.strokeStyle.lineWidth;
  context.strokeStyle = material.strokeStyle && material.strokeStyle.color;
  context.fillStyle = material.fillStyle && material.fillStyle.color;
}

var makeState = () => {
  const events = makeEventHandler();

  const models = new Map();
  const objects = new Map();

  const modelIdGenerator = makeIdGenerator();
  const objectIdGenerator = makeIdGenerator();

  function loadModel(model) {
    if (
      !model ||
      typeof model !== "object" ||
      !model.objects ||
      typeof model.objects !== "object" ||
      !model.objects.length
    ) {
      throw 'model should be an object with an non empty array of "objects".';
    }
    model.id = modelIdGenerator();
    models.set(model.id, model);
    const newObjects = [];
    model.objects.forEach(object => {
      addMissingObjectBasicProperties(object);
      object.model = model;
      object.id = objectIdGenerator();
      objects.set(object.id, object);
      newObjects.push(object);
    });
    events.emit("objects-added", newObjects);
    events.emit("model-loaded", model);
  }

  function unloadModel(modelId) {
    const model = models.get(modelId);
    if (model) {
      model.objects.forEach(object => objects.delete(object.id));
      events.emit("objects-removed", model.objects);
      models.delete(modelId);
      events.emit("model-unloaded", model);
      return true;
    } else {
      return false;
    }
  }

  function getObject(objectId) {
    const object = Array.from(objects.values()).find(
      object => object.id === objectId
    );
    return object ? Object.freeze({ ...object }) : undefined;
  }

  function getObjects() {
    return Array.from(objects.values()).map(object =>
      Object.freeze({ ...object })
    );
  }

  function getModels() {
    return Array.from(models.values());
  }

  const makeObjectsPropertySetter = property => (ids = [], value) => {
    if (!Array.isArray(ids)) throw "Ids must be an Array";
    const updatedObjects = [];
    ids
      .map(id => objects.get(id))
      .filter(Boolean)
      .forEach(o => {
        if (o[property] !== value) {
          o[property] = value;
          updatedObjects.push(o);
        }
      });
    if (updatedObjects.length) {
      events.emit(`objects-${value ? "" : "un"}${property}`, updatedObjects);
    }
  };

  function makeObjectsPropertySetters(properties = []) {
    return properties.reduce((o, property) => {
      o[
        `setObjects${capitalCaseFirstLetter(property)}`
      ] = makeObjectsPropertySetter(property);
      return o;
    }, {});
  }

  return {
    loadModel,
    unloadModel,
    getModels,
    getObject,
    getObjects,
    ...makeObjectsPropertySetters([
      "visible",
      "selected",
      "highlighted",
      "pickable",
    ]),
    ...events,
  };
};

function addMissingObjectBasicProperties(object) {
  object.visible = object.visible === undefined ? true : object.visible;
  object.pickable = object.pickable === undefined ? true : object.pickable;

  object.selected = object.selected === undefined ? false : object.selected;
  object.highlighted =
    object.highlighted === undefined ? false : object.highlighted;
}

const materials = {
  default: {
    strokeStyle: {
      lineWidth: 1,
      color: new Uint8ClampedArray([0, 0, 0]),
      opacity: 1,
    },
  },
  highlighted: {
    strokeStyle: {
      lineWidth: 2,
      color: new Uint8ClampedArray([0, 0, 255]),
      opacity: 1,
    },
    fillStyle: {
      color: new Uint8ClampedArray([0, 0, 200]),
      opacity: 0.1,
    },
  },
  selected: {
    strokeStyle: {
      lineWidth: 3,
      color: new Uint8ClampedArray([0, 255, 0]),
      opacity: 1,
    },
    fillStyle: {
      color: new Uint8ClampedArray([0, 200, 0]),
      opacity: 0.4,
    },
  },
};

function makeStateRenderAdapter(state, renderer) {
  const materials$1 = { ...materials };

  const parsedMaterials = new Map();

  function parseMaterial(material = {}) {
    if (parsedMaterials.has(material)) {
      return parsedMaterials.get(material);
    } else {
      const parsedMaterial = {};
      if (material.strokeStyle) {
        parsedMaterial.strokeStyle = {
          lineWidth: material.strokeStyle.lineWidth,
          color: fromUint8ArrayColorToStringColor(
            material.strokeStyle.color,
            material.strokeStyle.opacity
          ),
        };
      }
      if (material.fillStyle) {
        parsedMaterial.fillStyle = {
          color: fromUint8ArrayColorToStringColor(
            material.fillStyle.color,
            material.fillStyle.opacity
          ),
        };
      }
      parsedMaterials.set(material, parsedMaterial);
      return parsedMaterial;
    }
  }

  function makeAdapterLayer(cfg) {
    const { name, objects = [], visible, batchPath, materialCallback } = cfg;
    const rendererLayer = renderer.addLayer(name, objects, visible, batchPath);

    return new Proxy(
      {
        rendererLayer,
        objects: {},
        removeObjects(objects) {
          let someObjectDeleted = false;
          objects.forEach(object => {
            if (this.objects[object.id] !== undefined) {
              delete this.objects[object.id];
              someObjectDeleted = true;
            }
          });
          if (someObjectDeleted) {
            this.updateRenderer();
          }
        },
        addObjects(objects) {
          objects.forEach(object => {
            this.objects[object.id] = {
              rank: -object.area,
              path: object.path,
              material: materialCallback(object),
            };
          });
          this.updateRenderer();
        },
        updateRenderer() {
          renderer.setLayerObjects(
            name,
            Object.values(this.objects).sort((a, b) =>
              a.rank > b.rank ? 1 : a.rank < b.rank ? -1 : 0
            )
          );
        },
      },
      {
        // automatic bind methods
        get(target, key) {
          return typeof target[key] === "function"
            ? target[key].bind(target)
            : target[key];
        },
      }
    );
  }

  function getMaterialByObjectType(type) {
    return Object.values(materials$1)
      .filter(material => material.types)
      .find(material => material.types.includes(type));
  }

  const mainAdapterLayer = makeAdapterLayer({
    name: "main",
    materialCallback: object =>
      parseMaterial(getMaterialByObjectType(object.type) || materials$1.default),
  });
  const pickingAdapterLayer = makeAdapterLayer({
    name: "picking",
    visible: false,
    batchPath: false,
    materialCallback: object => ({
      fillStyle: { color: getRGBStringColorFromId(object.id) },
    }),
  });
  const selectedObjectsAdapterLayer = makeAdapterLayer({
    name: "select",
    materialCallback: () => parseMaterial(materials$1.selected),
  });
  const highlightedObjectsAdapterLayer = makeAdapterLayer({
    name: "highlight",
    materialCallback: () => parseMaterial(materials$1.highlighted),
  });

  state.on("objects-added", onObjectsAdded);

  state.on("objects-removed", onObjectsRemoved);

  state.on("objects-selected", objects =>
    selectedObjectsAdapterLayer.addObjects(objects.filter(o => o.visible))
  );

  state.on("objects-unselected", selectedObjectsAdapterLayer.removeObjects);

  state.on("objects-highlighted", objects =>
    highlightedObjectsAdapterLayer.addObjects(objects.filter(o => o.visible))
  );

  state.on(
    "objects-unhighlighted",
    highlightedObjectsAdapterLayer.removeObjects
  );

  state.on("objects-pickable", objects =>
    pickingAdapterLayer.addObjects(objects.filter(o => o.visible))
  );

  state.on("objects-unpickable", pickingAdapterLayer.removeObjects);

  state.on("objects-visible", objects => {
    mainAdapterLayer.addObjects(objects);
    pickingAdapterLayer.addObjects(objects.filter(object => object.pickable));
    selectedObjectsAdapterLayer.addObjects(
      objects.filter(object => object.selected)
    );
    highlightedObjectsAdapterLayer.addObjects(
      objects.filter(object => object.highlighted)
    );
  });

  state.on("objects-unvisible", objects => {
    removeObjectsOfAllAdapterLayers(objects);
  });

  function onObjectsAdded(objects) {
    const visibleObjects = objects.filter(object => object.visible);
    mainAdapterLayer.addObjects(visibleObjects);
    pickingAdapterLayer.addObjects(
      visibleObjects.filter(object => object.pickable)
    );
    selectedObjectsAdapterLayer.addObjects(
      visibleObjects.filter(object => object.selected)
    );
    highlightedObjectsAdapterLayer.addObjects(
      visibleObjects.filter(object => object.highlighted)
    );
  }

  function onObjectsRemoved(objects) {
    removeObjectsOfAllAdapterLayers(objects);
  }

  function removeObjectsOfAllAdapterLayers(objects) {
    [
      mainAdapterLayer,
      pickingAdapterLayer,
      selectedObjectsAdapterLayer,
      highlightedObjectsAdapterLayer,
    ].forEach(adapterLayer => adapterLayer.removeObjects(objects));
  }

  return {
    materials: materials$1,
    getObjectAtPosition(position) {
      const pickingContext = pickingAdapterLayer.rendererLayer.context;
      const { data: color } = pickingContext.getImageData(
        position.x,
        position.y,
        1,
        1
      );
      const id = getIdFromRGBColor(color);
      const object = state.getObject(id);
      return object;
    },
  };
}

function makeClock(
  nextTick = window.requestAnimationFrame,
  now = performance.now.bind(performance)
) {
  if (typeof nextTick !== "function") {
    throw `"nextTick" must be a function, get "${typeof nextTick}".`;
  }
  if (typeof now !== "function") {
    throw `"now" must be a function, get "${typeof now}".`;
  }
  const events = makeEventHandler();
  let running = false;
  let time = null;
  let nextTickFunction = null;

  function tick() {
    const t = now();
    const dt = t - time;
    if (nextTickFunction) {
      nextTickFunction(dt);
      nextTickFunction = null;
    }
    events.emit("tick", dt);
    time = t;
  }

  return {
    start() {
      running = true;
      time = now();
      tick();
      let runningFunction = null;
      nextTick(
        (runningFunction = () => {
          if (running) {
            tick();
            nextTick(runningFunction);
          }
        })
      );
    },
    stop() {
      running = false;
    },
    nextTick(func) {
      if (typeof func !== "function") {
        throw `nextTick argument must be a function, get ${typeof func}.`;
      }
      nextTickFunction = func;
    },
    ...events,
  };
}

const Viewer2DFactory = (cfg = {}) => {
  const {
    canvas,
    rotateKey = "shift",
    scaleSpeed = 0.002,
    rotateSpeed = 0.1,
    maxScale = 1000,
    minScale = 1,
    fitViewRatio = 1,
    arrowMove = 5,
    Matrix = DOMMatrixReadOnly,
  } = cfg;
  if (!(canvas instanceof HTMLCanvasElement)) {
    throw "Canvas must be a HTMLCanvasElement";
  }
  if (typeof rotateKey !== "string") {
    throw `"rotateKey" argument must be a string, get "${typeof rotateKey}"`;
  }
  [scaleSpeed, rotateSpeed, maxScale, minScale, fitViewRatio].forEach(arg => {
    if (typeof arg !== "number") {
      throw `"${arg}" argument must be a number, get "${typeof arg}"`;
    }
  });

  const state = makeState();
  const renderer = makeRenderer(canvas);
  const stateRendererAdapter = makeStateRenderAdapter(state, renderer);

  const events = makeEventHandler();

  state.on("model-loaded", model => events.emit("model-loaded", model));

  const transform2D = Transform2D({
    viewport: renderer.getViewport(),
    maxScale,
    minScale,
    Matrix,
  });

  // keep draw area center aligned with canvas center on resize
  renderer.on("resize", ({ dx, dy }) => transform2D.translate(dx / 2, dy / 2));

  const ui = UI(canvas);
  ui.on("drag", ({ dx, dy }) => transform2D.translate(dx, dy));
  ui.on("wheel", ({ dy, position, keys }) => {
    if (keys[rotateKey]) {
      const angle = dy * rotateSpeed;
      transform2D.rotate(angle, position);
    } else {
      const factor = Math.max(1 - dy * scaleSpeed, 0);
      transform2D.scale(factor, position);
    }
  });
  ui.on("click", ({ position, keys }) => {
    const object = stateRendererAdapter.getObjectAtPosition(position);
    if (object) {
      events.emit("pick", { object, position, keys });
    } else {
      events.emit("pick-nothing", { position, keys });
    }
  });
  ui.on("right-click", ({ position, keys }) => {
    const object = stateRendererAdapter.getObjectAtPosition(position);
    if (object) {
      events.emit("pick", { object, position, rightClick: true, keys });
    } else {
      events.emit("pick-nothing", { position, rightClick: true, keys });
    }
  });
  let lastHighlightedObject = null;
  ui.on("move", ({ position }) => {
    const object = stateRendererAdapter.getObjectAtPosition(position);
    if (object) {
      if (lastHighlightedObject) {
        if (object.id === lastHighlightedObject.id) {
          events.emit("hover-surface", { object, position });
        } else {
          events.emit("hover", { object, position });
          events.emit("hover-out", { object: lastHighlightedObject, position });
          lastHighlightedObject = object;
        }
      } else {
        events.emit("hover", { object, position });
        lastHighlightedObject = object;
      }
    } else {
      if (lastHighlightedObject) {
        events.emit("hover-out", { object: lastHighlightedObject, position });
        lastHighlightedObject = null;
      }
      events.emit("hover-off", { position });
    }
  });

  ui.on("arrow-up", () => transform2D.translate(0, -arrowMove));
  ui.on("arrow-right", () => transform2D.translate(arrowMove));
  ui.on("arrow-down", () => transform2D.translate(0, arrowMove));
  ui.on("arrow-left", () => transform2D.translate(-arrowMove));

  const clock = makeClock();
  clock.on("tick", dt => {
    renderer.setTransform(transform2D.getTransform());
    renderer.render();
    events.emit("tick", dt);
  });
  clock.start();

  function destroy() {
    clock.stop();
  }

  return {
    get materials() {
      return stateRendererAdapter.materials;
    },
    loadModel: state.loadModel,
    unloadModel: state.unloadModel,
    scene: {
      get models() {
        return state.getModels();
      },
      get objects() {
        return state.getObjects();
      },
      setObjectsVisible: state.setObjectsVisible,
      setObjectsSelected: state.setObjectsSelected,
      setObjectsHighlighted: state.setObjectsHighlighted,
      setObjectsPickable: state.setObjectsPickable,
    },
    camera: {
      fitView(bbox) {
        transform2D.fitView(getQuadFromBBox(bbox));
      },
    },
    destroy,
    ...events,
  };
};

export default Viewer2DFactory;
//# sourceMappingURL=viewer2D.esm.js.map
